//FarbenMuster_207d.js
// 11.10.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Erzeugt CMYK- oder RGB-Farbenmuster

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die ".csv"- oder ".txt"-Datei auswhlen lassen ...
var sourceFolder = new Folder("~/Documents/Farbenmuster");
var sourceFile   = File(sourceFolder).openDlg("Die \".csv\"- oder \".txt\"-Datei auswhlen:");
if (sourceFile  == null) {
	exit();
}

// ... und einlesen
var numberString = "";
var f = File(sourceFile);
var fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		numberString = f.read();
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}
if (numberString == "") {
	alert ("Die Datei konnte nicht gelesen werden.", "Achtung");
	exit();
}

// den verwendeten Separatoren speichern
var sepType = "";
if (numberString.indexOf("\t") != -1) {
	sepType = "\t";
}
else if (numberString.indexOf(";") != -1) {
	sepType = ";";
}
if (sepType == "") {
	alert ("Kein gltiger Separator (Tab oder Strichpunkt) gefunden.", "Stop");
	exit();
}

// die verwendete Absatzmarke speichern
var retType = "";
if (numberString.indexOf("\r") != -1) {
	retType = "\r";
}
else if (numberString.indexOf("\n") != -1) {
	retType = "\n";
}
else if (numberString.indexOf("\r\n") != -1) {
	retType = "\r\n";
}
if (retType == "") {
	alert ("Keine gltige Absatzmarke (Return, New Line) gefunden.", "Stop");
	exit();
}

// speichern, ob RGB oder CMYK gefragt ist
var colType = "";
var noType  = false;
if (numberString.indexOf("CMYK") != -1) {
	colType = "CMYK";
}
else if (numberString.indexOf("RGB") != -1) {
	colType = "RGB";
}
if (colType == "") {
	noType = true;
	nParts = 0;
	// die Textkette in eine Liste verwandeln
	try {
		var testList   = numberString.split(retType);
		var testString = testList[1];
		var nParts = testString.split(sepType).length;
	}
	catch (e) {
	}
	if (nParts == 3) {
		colType = "RGB";
	}
	else if (nParts == 4) {
		colType = "CMYK";
	}
	else {
		alert ("CMYK oder RGB?\nKann nicht festgestellt werden.", "Stop");
		exit();
	}
}

// sicherstellen, dass fr RGB keine Nachkommastellen definiert werden
if (colType == "RGB") {
	if (numberString.indexOf(",") != -1) {
		alert ("Kommas sind nicht zugelassen\n(weder als Trenner noch in den RGB-Werten)", "Stop");
		exit();
	}
	else if (numberString.indexOf(".") != -1) {
		alert ("Punkte sind nicht zugelassen\n(weder als Trenner noch in den RGB-Werten)", "Stop");
		exit();
	}
}

// speichern, ob die Textdatei Kommas enthlt
insCommas = false;
if (numberString.indexOf(",") != -1) {
	insCommas = true;
}

// eventuelle Leerzeilen lschen
objRegExp  = new RegExp(retType+retType, "g");
numberString = numberString.replace(objRegExp, "");

// einen eventuellen ersten Return entfernen
if (numberString[0] == retType) {
	numberString = numberString.slice(1);
}

// einen eventuellen letzten Return entfernen
if (numberString[numberString.length-1] == retType) {
	numberString = numberString.slice(0,-1);
}

// eventuelle Kommas in Punkte verwandeln
objRegExp  = new RegExp(",", "g");
numberString = numberString.replace(objRegExp, ".");

// die Textkette in eine Liste verwandeln
var numberList = numberString.split(retType);

if (noType == false) {
	// das erste Element der Liste entfernen (= Zeile CMYK oder RGB)
	numberList.shift();
}

// die Liste in einen Teststring verwandeln
testString = numberList.join(sepType);
// Separatoren ...
objRegExp  = new RegExp(sepType, "g");
numbString = testString.replace(objRegExp, "");
// ... und Punkte daraus entfernen
numbString = numbString.replace(/\./g, "");
// prfen, ob nur Ziffern aufgelistet sind
if (isNaN(numbString)) {
	alert ("Mindestens *ein* Zeichen ist keine Ziffer.", "Stop");
	exit();
}

// die Anzahl zu erzeugender Farbfelder speichern
nColors = numberList.length;

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
if (allPrefs != "") {
	prefVal = allPrefs.split("\n");
	wVal = prefVal[0]*1;
	hVal = prefVal[1]*1;
	sVal = prefVal[2]*1;
	dVal = prefVal[3]*1;
	mVal = prefVal[4]*1;
	cVal = prefVal[5];
	rVal = prefVal[6];
	bVal = prefVal[7];
	rb01 = 1;
	rb02 = 0;
	if (bVal == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	fVal = prefVal[8];
	rb03 = 1;
	rb04 = 0;
	if (fVal == "1") {
		rb03 = 0;
		rb04 = 1;
	}
	vVal = prefVal[9];
	rb05 = rb06 = rb07 = rb08 = 0;
	if (vVal == "0") {
		rb05 = 1;
	}
	else if (vVal == "1") {
		rb06 = 1;
	}
	else if (vVal == "2") {
		rb07 = 1;
	}
	else if (vVal == "3") {
		rb08 = 1;
	}
	nVal = prefVal[10]*1;
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde, 
	// auf die folgenden Vorgabenwerte zurckgreifen
	wVal = 210;
	hVal = 297;
	sVal =   6;
	dVal =   1;
	mVal =   0;
	cVal =  "";
	rVal =  "";
	rb01 =   1;
	rb02 =   0;
	rb03 =   1;
	rb04 =   0;
	rb05 =   1;
	rb06 =   0;
	rb07 =   0;
	rb08 =   0;
	nVal =   0;
}

// "Gelb", "Schwarz" und "G" (oder "V") bestimmen
if ((app.locale)*1 == 1279477362) { // franzsisches InDesign
	var yChar = "J";
	var kChar = "N";
	var gChar = "V";
}
else if ((app.locale)*1 == 1279477613) { // deutsches InDesign
	var yChar = "Y";
	var kChar = "K";
	var gChar = "G";
}
else if ((app.locale)*1 == 1279477102 || (app.locale)*1 == 1279477097) { // englisches InDesign
	var yChar = "Y";
	var kChar = "K";
	var gChar = "G";
}
else {
	var yChar = "Y";
	var kChar = "K";
	var gChar = "G";
}

// testen, ob ein Dokument geffnet ist
var noDoc = false;
if (app.documents.length == 0) {
	noDoc = true;
}
else {
	// den Dokumentpfad speichern
	var curDoc = app.documents[0];
	try {
		var docPath   = curDoc.fullName;
	}
	catch (e) {
		alert ("Das Dokument speichern.", "Achtung");
		exit();
	}
}

// die Funktion aufrufen, welche den Dialog zeigt und auswertet
var anArray = displayDialog();
// den Variablen die zurckerhaltenen Werte zuweisen
var wVal = anArray[0]*1;
var hVal = anArray[1]*1;
var sVal = anArray[2]*1;
var dVal = anArray[3]*1;
var mVal = anArray[4]*1;
var nCls = anArray[5];
var nRws = anArray[6];
var rDec = anArray[7]*1;
var sDec = anArray[8]*1;
var vDec = anArray[9]*1;
var nVal = anArray[10]*1;

// die Drehwinkelwerte vorbereiten
var rotFrames = false;
if (nVal>0) {
	rotFrames = true;
	rotValues = new Array ();
	for (var r=(-nVal); r<(nVal+1); r++) {
		rotValues.push(r);
	}
}

// prfen ob individueller Spalten- und/oder Reihen-Wert 
if (nCls == "") { nCls = 0; }
else { nCls = nCls*1; }
if (nRws == "") { nRws = 0; }
else { nRws = nRws*1; }

if (noDoc == false) {
	// die Masseinheiten speichern
	// wenn nicht 2053991795 (= Millimeter), dann auf Millimeter umstellen
	hM = (curDoc.viewPreferences.horizontalMeasurementUnits)*1;
	vM = (curDoc.viewPreferences.verticalMeasurementUnits)*1;
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	}
	// den Nullpunkt auf Null/Null setzen
	var zP = curDoc.zeroPoint; 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = [0,0]; 
	}
	// wenn Drehwinkel, dann Bezugspunkt speichern und ndern
	if (rotFrames) {
		oldPoint = app.layoutWindows[0].transformReferencePoint;
		app.layoutWindows[0].transformReferencePoint = AnchorPoint.CENTER_ANCHOR;
	}
	// die aktive Ebene entsperren (falls notwendig)
	var isLocked = false;
	var curLayer = app.activeWindow.activeLayer;
	if (curLayer.locked) {
		curLayer.locked = false;
		isLocked = true;
	}
	// das Seitenformat speichern
	var pWidth  = Math.round(curDoc.documentPreferences.pageWidth);
	var pHeight = Math.round(curDoc.documentPreferences.pageHeight);
	// die mgliche Anzahl Rahmen pro Reihe ...
	var nHor = Math.floor((pWidth+dVal-mVal)/(sVal+dVal));
	// ... und Spalte und ausrechnen
	var nVer = Math.floor((pHeight+dVal-mVal)/(sVal+dVal));
	// falls ein persnlicher Wert gewnscht ist
	if (nCls > 0) {
		if (nCls > nHor) {
			alert ("Nur " + nHor + " Spalten sind mglich.\n(und nicht " + nCls + ")", "Achtung"); 
			resetAsBefore();
			exit();
		}
		else {
			var nHor = nCls;
		}
	}
	if (nRws > 0) {
		if (nRws > nVer) {
			alert ("Nur " + nVer + " Reihen sind mglich.\n(und nicht " + nRws + ")", "Achtung"); 
			resetAsBefore();
			exit();
		}
		else {
			var nVer = nRws;
		}
	}
	// das Ergebnis prfen
	if (nHor < 1) {
		alert ("Anzahl Spalten = 0", "Stop");
		resetAsBefore();
		exit();
	}
	else if (nVer < 1) {
		alert ("Anzahl Reihen = 0", "Stop");
		resetAsBefore();
		exit();
	}
	// die Anzahl Rahmen pro Seite
	var nPerPage = nHor*nVer;
	// die Anzahl Reihen
	var nRows = Math.ceil(nColors/nHor);
	// die Anzahl Spalten
	var nCols = Math.ceil(nColors/nVer);
	// die Anzahl Seiten
	var nPages = Math.ceil(nColors/nPerPage);
	if (nPages > 999) {
		var userDec = confirm ("Achtung: " + nPages + " Seiten sind notwendig. Weiterfahren?");
	}
	if (userDec == false) {
		resetAsBefore();
		exit();
	}
	// die notwendige Anzahl Seiten einfgen
	if (nPages>1) {
		for (var i=curDoc.pages.length; i<nPages; i++) {
			curDoc.pages.add();
		}
	}
	// ... das Dokument speichern, schliessen ...
	curDoc.close(SaveOptions.yes);
	// ... und unsichtbar ffnen
	curDoc = app.open(File(docPath), false);
}

if (noDoc) {
	// wenn Drehwinkel, dann Bezugspunkt ndern
	if (rotFrames) {
		// ein Dokument erzeugen, damit der Bezugspunkt gendert werden kann
		curDoc = app.documents.add();
		// Bezugspunkt speichern
		oldPoint = app.layoutWindows[0].transformReferencePoint;
		// Bezugspunkt in der Mitte auswhlen
		app.layoutWindows[0].transformReferencePoint = AnchorPoint.CENTER_ANCHOR;
		// Dokument wieder schliessen
		curDoc.close();
	}
	// ein Dokument erzeugen
	curDoc = app.documents.add(false, undefined);
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.documentPreferences.properties = {pageWidth:wVal, pageHeight:hVal, facingPages:false};
	with (curDoc.masterSpreads[0].pages.item(0).marginPreferences) {
		top=0;
		left=0;
		bottom=0;
		right=0;
	}
	// die mgliche Anzahl Rahmen pro Reihe ...
	var nHor = Math.floor((wVal+dVal-mVal)/(sVal+dVal));
	// ... und Spalte und ausrechnen
	var nVer = Math.floor((hVal+dVal-mVal)/(sVal+dVal));
	// falls ein persnlicher Wert gewnscht ist
	if (nCls > 0) {
		if (nCls > nHor) {
			alert ("Nur " + nHor + " Spalten sind mglich.\n(und nicht " + nCls + ")", "Achtung"); 
			// das Dokument schliessen
			curDoc.close(SaveOptions.NO);
			exit();
		}
		else {
			var nHor = nCls;
		}
	}
	if (nRws > 0) {
		if (nRws > nVer) {
			alert ("Nur " + nVer + " Reihen sind mglich.\n(und nicht " + nRws + ")", "Achtung"); 
			curDoc.windows.add();
			// das Dokument schliessen
			curDoc.close(SaveOptions.NO);
			exit();
		}
		else {
			var nVer = nRws;
		}
	}
	// das Ergebnis prfen
	if (nHor < 1) {
		alert ("Anzahl Spalten = 0", "Stop");
		// das Dokument schliessen
		curDoc.close(SaveOptions.NO);
		exit();
	}
	else if (nVer < 1) {
		alert ("Anzahl Reihen = 0", "Stop");
		// das Dokument schliessen
		curDoc.close(SaveOptions.NO);
		exit();
	}
	// die Anzahl Rahmen pro Seite
	var nPerPage = nHor*nVer;
	// die Anzahl Reihen
	var nRows = Math.ceil(nColors/nHor);
	// die Anzahl Spalten
	var nCols = Math.ceil(nColors/nVer);
	// die Anzahl Seiten
	var nPages = Math.ceil(nColors/nPerPage);
	if (nPages > 999) {
		var userDec = confirm ("Achtung: " + nPages + " Seiten sind notwendig. Weiterfahren?");
	}
	if (userDec == false) {
		// das Dokument schliessen
		curDoc.close(SaveOptions.NO);
		exit();
	}
	// die notwendige Anzahl Seiten einfgen
	if (nPages>1) {
		for (var i=curDoc.pages.length; i<nPages; i++) {
			curDoc.pages.add();
		}
	}
}

// fr die Spirale die Richtungs-Liste erzeugen
// 1 = nach rechts; 2 = nach oben; 3 = nach links; 4 = nach unten
if (vDec == 2) {
	var hDif = 0;
	var vDif = 0;
	if (nHor > nVer) {
		hDif = (nHor-nVer);
		if (hDif > 1) { 
			hDif = hDif-1;
		}
	}
	else {
		vDif = nVer-nHor;
		if (vDif > 1) { 
			vDif = vDif-1;
		}
	}
	var ctr = 0;
	if (nHor == nVer || hDif > 0) {
		var dirVal = 2;
	}
	else {
		var dirVal = 4;
	}
	var chgVal = 0;
	var dirValList = new Array ();
	dirValList.push(0);
	while (dirValList.length < nPerPage) {
		if (nHor == nVer || hDif > 0) {
			if (ctr%2 == 1) {
				chgVal++;
			}
		}
		else {
			if (ctr%2 == 0) {
				chgVal++;
			}
		}
		if (hDif == 0 && vDif == 0) {
			for (var x=0; x<chgVal; x++) {
				dirValList.push(dirVal);
				if (dirValList.length == nPerPage) {
					break;
				}
			}
		}
		else {
			if (hDif > 0) {
				if (dirVal == 1 || dirVal == 3) {
					for (var x=0; x<chgVal+hDif; x++) {
						dirValList.push(dirVal);
						if (dirValList.length == nPerPage) {
							break;
						}
					}
				}
				else {
					for (var x=0; x<chgVal; x++) {
						dirValList.push(dirVal);
						if (dirValList.length == nPerPage) {
							break;
						}
					}
				}
			}
			else if (vDif > 0) {
				if (dirVal == 2 || dirVal == 4) {
					for (var x=0; x<chgVal+vDif; x++) {
						dirValList.push(dirVal);
						if (dirValList.length == nPerPage) {
							break;
						}
					}
				}
				else {
					for (var x=0; x<chgVal; x++) {
						dirValList.push(dirVal);
						if (dirValList.length == nPerPage) {
							break;
						}
					}
				}
			}
		}
		dirVal++;
		if (dirVal > 4) {
			dirVal = 1;
		}
		ctr++;
	}
}

// falls gewnscht, die Zufallszahlen vorbereiten
if (vDec == 3) {
	var maxVal = nColors;
	// einen Array initialisieren
	var numArray = new Array ();
	// den Prfstring initialisieren
	var testString = "";
	// eine Schleife, bis die Anzahl der Zahlen stimmt
	while (numArray.length < maxVal) {
		var okay = true;
		// eine innere Schleife
		while (okay == true) {
			okay = false;
			// Zufallszahl generieren
			num = Math.floor(Math.random()*maxVal); // von 0 bis maxVal-1
			// die aktuelle Nummer mit Pipes umgeben
			var testNumber = "|" + num + "|";
			// prfen, ob Zahl schon vorhanden
			if (testString.indexOf(testNumber) == -1) {
				// die aktuelle Zahl an die Liste anfgen
				numArray.push(num);
				// den Prfstring aktualisieren
				testString = "|" + (numArray.join("|")) + "|";
				// wenn 'okay', dann wird die Schleife verlassen
				okay = true;
			}
		}
	}
}

// Versatzwerte und Startpositionen vorbereiten
var yOff = sVal+dVal;
var xOff = sVal+dVal;

// die Farbfelder und Rahmen der aktuellen Reihe (oder Spalte) erzeugen
var ctr = 0;
var p   = -1;
var rcCtr  = 0;
var rotVal = 0;
for (var i=0; i<nColors; i++) {
	if (i%nPerPage == 0) {
		p++;
		if (rDec == 0) {
			if (vDec != 2) {
				var y1 = mVal-yOff;
				if (vDec == 0) {
					var x1 = mVal;
				}
				else {
					if (i>1) {
						if (rcCtr%2 == 0) {
							x1 = mVal;
						}
						else {
							x1 = x1;
						}
					}
					else {
						x1 = mVal;
					}
				}
			}
		}
		else {
			if (vDec != 2) {
				var x1 = mVal-xOff;
				if (vDec == 0) {
					var y1 = mVal;
				}
				else {
					if (i>1) {
						if (rcCtr%2 == 0) {
							y1 = mVal;
						}
						else {
							y1 = y1;
						}
					}
					else {
						y1 = mVal;
					}
				}
			}
		}
	}
	if (vDec == 2 && rDec == 1) {
		var curCol = (numberList[(nColors-1)-i]).split(sepType);
	}
	else if (vDec == 3) {
		var x = numArray[i];
		var curCol = (numberList[x]).split(sepType);
	}
	else {
		var curCol = (numberList[i]).split(sepType);
	}
	if (colType == "CMYK") {
		c = curCol[0]*1;
		m = curCol[1]*1;
		y = curCol[2]*1;
		k = curCol[3]*1;
		var valTest = testCMYKvalues(c,m,y,k);
		if (valTest == "no good") {
			// warnen ...
			alert ("Zeile " + (i+1) + " hat nicht *vier* Werte.", "Stop");
			// ... das Dokument sichtbar machen ...
			curDoc.windows.add();
			// ... Vorgaben zurcksetzen ...
			resetAsBefore();
			// ... und abbrechen
			exit();
		}
		var curValues = [c,m,y,k];
		var testName  = "C=" + c + " M=" + m + " " + yChar + "=" + y + " " + kChar + "=" + k;
		// wenn in der Textdatei Kommas vorkommen
		if (insCommas) {
			// eventuelle Punkte wieder durch Kommas ersetzen
			testName = testName.replace(/\./g, ",");
		}
		try {
			testColor = curDoc.colors.itemByName(testName).name;
			curColor  = curDoc.colors.itemByName(testName);
		}
		catch (e) {
			curColor  = curDoc.colors.add({space:ColorSpace.CMYK, colorValue:curValues, name:testName});
		}
	}
	else {
		r = curCol[0]*1;
		g = curCol[1]*1;
		b = curCol[2]*1;
		var valTest = testRGBvalues(r,g,b);
		if (valTest == "no good") {
			// warnen ...
			alert ("Zeile " + (i+1) + " hat nicht *drei* Werte.", "Stop");
			// ... das Dokument sichtbar machen ...
			curDoc.windows.add();
			// ... Vorgaben zurcksetzen ...
			resetAsBefore();
			// ... und abbrechen
			exit();
		}
		var curValues = [r,g,b];
		var testName  = "R=" + r + " " + gChar + "=" + g + " B=" + b;
		try {
			testColor = curDoc.colors.itemByName(testName).name;
			curColor  = curDoc.colors.itemByName(testName);
		}
		catch (e) {
			curColor  = curDoc.colors.add({space:ColorSpace.RGB, colorValue:curValues});
		}
	}

	// das Label des Rahmens
	if (vDec == 2 && rDec == 1) {
		var curLabel = "" + ((nColors)-i);
	}
	else if (vDec == 3) {
		var curLabel = "" + (numArray[i]+1);
	}
	else {
		var curLabel = "" + (i+1);
	}
	
	// der aktuelle Drehwinkel
	if (rotFrames) {
		num = Math.floor(Math.random()*rotValues.length);
		rotVal = rotValues[num];
	}
	
	if (rDec == 0) { // wenn horizontaler Aufbau
		if (i%nHor == 0) {
			if (vDec != 2) {
				// die Y-Position um den Versatzwert erhhen
				y1 = y1+yOff;
				if (vDec == 0) {
					x1 = mVal;
				}
				else {
					if (i>1) {
						if (rcCtr%2 == 0) {
							x1 = mVal;
						}
						else {
							x1 = x1-xOff;
						}
					}
				}
			}
			rcCtr++;
		}
		if (vDec == 2) { // wenn spiralenfrmig
			if (i == 0 || i%nPerPage == 0) {
				y1 = mVal + ((Math.floor(nVer/2))*yOff);
				x1 = mVal + ((Math.floor(nHor/2))*xOff);
				if (hDif == 0 && vDif == 0) {
					if (nVer%2 == 0) {
						y1 = y1 - yOff;
					}
				}
				if (hDif != 0) {
					if (nVer%2 == 0) {
						y1 = y1-yOff;
					}
				}
				if (vDif != 0) {
					y1 = y1 - ((Math.floor((vDif-1)/2))*yOff)-yOff;
					if (nVer%2 == 0) {
						if (vDif>1 && nHor%2 == 1) {
							y1 = y1 - yOff;
						}
					}
				}
				if (hDif != 0) {
					if (nHor%2 == 0) {	
						x1 = x1 + (Math.ceil((hDif-1)/2))*xOff;
					}
					else {
						x1 = x1 + (Math.ceil(hDif/2))*xOff;
					}
				}
				if (vDif != 0) {
					if (nHor%2 == 0) {	
						x1 = x1 + ((Math.ceil((hDif-1)/2))*xOff)-xOff;
					}
					else {
						x1 = x1 + (Math.ceil(hDif/2))*xOff;
					}
				}
				var ctr = 1;
			}
			else {
				curDir = dirValList[ctr];
				if (curDir == 1) {
					x1 = x1+xOff;
				}
				else if (curDir == 2) {
					y1 = y1-yOff;
				}
				else if (curDir == 3) {
					x1 = x1-xOff;
				}
				else if (curDir == 4) {
					y1 = y1+yOff;
				}
				ctr++;
			}
		}
		// den aktuellen Rahmen erzeugen
		if (sDec == 0) {
			curDoc.pages[p].rectangles.add({geometricBounds:[y1,x1,y1+sVal,x1+sVal], fillColor:curColor, fillTint:100, strokeColor:"None", label:curLabel, rotationAngle:rotVal});
		}
		else {
			curDoc.pages[p].ovals.add({geometricBounds:[y1,x1,y1+sVal,x1+sVal], fillColor:curColor, fillTint:100, strokeColor:"None", label:curLabel});
		}
		if (vDec == 2) {
			// nichts mehr tun
		}
		else if (vDec == 0 || rcCtr == 0) {
			// die X-Position um den Versatzwert erhhen
			x1 = x1+xOff;
		}
		else {
			if (rcCtr%2 == 0) {
				// die X-Position um den Versatzwert verringern
				x1 = x1-xOff;
			}
			else {
				x1 = x1+xOff;
			}
		}
	}
	else { // wenn vertikaler Aufbau
		if (i%nVer == 0) {
			if (vDec != 2) {
				// die X-Position um den Versatzwert erhhen
				x1 = x1+xOff;
				if (vDec == 0) {
					y1 = mVal;
				}
				else {
					if (i>1) {
						if (rcCtr%2 == 0) {
							y1 = mVal;
						}
						else {
							y1 = y1-yOff;
						}
					}
				}
			}
			rcCtr++;
		}
		if (vDec == 2) { // wenn spiralenfrmig
			if (i == 0 || i%nPerPage == 0) {
				y1 = mVal + ((Math.floor(nVer/2))*yOff);
				x1 = mVal + ((Math.floor(nHor/2))*xOff);
				if (hDif == 0 && vDif == 0) {
					if (nVer%2 == 0) {
						y1 = y1 - yOff;
					}
				}
				if (hDif != 0) {
					if (nVer%2 == 0) {
						y1 = y1-yOff;
					}
				}
				if (vDif != 0) {
					y1 = y1 - ((Math.floor((vDif-1)/2))*yOff)-yOff;
					if (nVer%2 == 0) {
						if (vDif>1 && nHor%2 == 1) {
							y1 = y1 - yOff;
						}
					}
				}
				if (hDif != 0) {
					if (nHor%2 == 0) {	
						x1 = x1 + (Math.ceil((hDif-1)/2))*xOff;
					}
					else {
						x1 = x1 + (Math.ceil(hDif/2))*xOff;
					}
				}
				if (vDif != 0) {
					if (nHor%2 == 0) {	
						x1 = x1 + ((Math.ceil((hDif-1)/2))*xOff)-xOff;
					}
					else {
						x1 = x1 + (Math.ceil(hDif/2))*xOff;
					}
				}
				var ctr = 1;
			}
			else {
				curDir = dirValList[ctr];
				if (curDir == 1) {
					x1 = x1+xOff;
				}
				else if (curDir == 2) {
					y1 = y1-yOff;
				}
				else if (curDir == 3) {
					x1 = x1-xOff;
				}
				else if (curDir == 4) {
					y1 = y1+yOff;
				}
				ctr++;
			}
		}
		// den aktuellen Rahmen erzeugen
		if (sDec == 0) {
			curDoc.pages[p].rectangles.add({geometricBounds:[y1,x1,y1+sVal,x1+sVal], fillColor:curColor, fillTint:100, strokeColor:"None", label:curLabel, rotationAngle:rotVal});
		}
		else {
			curDoc.pages[p].ovals.add({geometricBounds:[y1,x1,y1+sVal,x1+sVal], fillColor:curColor, fillTint:100, strokeColor:"None", label:curLabel});
		}
		if (vDec == 2) {
			// nichts mehr tun
		}
		else if (vDec == 0 || rcCtr == 0) {
			// die Y-Position um den Versatzwert erhhen
			y1 = y1+yOff;
		}
		else {
			if (rcCtr%2 == 0) {
				// die Y-Position um den Versatzwert verringern
				y1 = y1-yOff;
			}
			else {
				y1 = y1+yOff;
			}
		}
	}
}
// das Dokument sichtbar machen ...
curDoc.windows.add();
// ... und die erste Seite anzeigen
app.activeWindow.activePage = curDoc.pages[0];

// den Bezugspunkt zurcksetzen
if (rotFrames) {
	app.layoutWindows[0].transformReferencePoint = oldPoint;
}

// die Funktion zum Zurcksetzen auf die ursprnglichen Einstellungen aufrufen
resetAsBefore();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/farbenmuster207.txt");
	}
	else {
		var f = new File("~/Library/Preferences/farbenmuster207.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth1 = 190;
	var labelWidth2 =  92;
	var labelWidth3 = 161;
	var labelWidth4 = 106;
	var fieldWidth  =  32;
	var aDialog = app.dialogs.add({name:"FarbenMuster"});
	with (aDialog) {
		with (dialogColumns.add()) {
			if (noDoc) {
				with (dialogRows.add()) {
					with (borderPanels.add()) {
						with (dialogColumns.add()) {
							with (dialogRows.add()) {
								staticTexts.add({staticLabel:"Ein neues Dokument erzeugen:"});
								staticTexts.add({staticLabel:" ", minWidth:4});
							}
							with (dialogRows.add()) {
								staticTexts.add({staticLabel:"Breite:", minWidth:labelWidth1});
								var widthField = realEditboxes.add({editValue:wVal, minimumValue:30, maximumValue:1000, minWidth:fieldWidth});
								staticTexts.add({staticLabel:"mm"});
							}
							with (dialogRows.add()) {
								staticTexts.add({staticLabel:"Hhe:", minWidth:labelWidth1});
								var heightField = realEditboxes.add({editValue:hVal, minimumValue:30, maximumValue:1000, minWidth:fieldWidth});
								staticTexts.add({staticLabel:"mm"});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Die Werte fr Kstchen und Abstnde:"});
							staticTexts.add({staticLabel:" ", minWidth:4});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Kstchenbreite und -hhe:", minWidth:labelWidth1});
							var sizeField = realEditboxes.add({editValue:sVal, minimumValue:1, maximumValue:25, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"mm"});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Spalten- und Reihen-Abstnde:", minWidth:labelWidth1});
							var guttField = realEditboxes.add({editValue:dVal, minimumValue:-10, maximumValue:10, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"mm"});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Abstand zum Seitenrand:", minWidth:labelWidth1});
							var distField = realEditboxes.add({editValue:mVal, minimumValue:0, maximumValue:10, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"mm"});
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Die Anzahl Spalten und Reihen (pro Seite):"});
							staticTexts.add({staticLabel:" ", minWidth:12});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Anzahl Spalten:", minWidth:labelWidth1});
							var colsField = textEditboxes.add({editContents:cVal, minWidth:fieldWidth});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Anzahl Reihen:", minWidth:labelWidth1});
							var rowsField = textEditboxes.add({editContents:rVal, minWidth:fieldWidth});
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Die Richtung: ", minWidth:labelWidth2});
							with (refButtons = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"horizontal aufbauen", checkedState:rb01, minWidth:labelWidth3});
								radiobuttonControls.add({staticLabel:"vertikal aufbauen", checkedState:rb02});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Rahmenform: ", minWidth:labelWidth2});
							with (shpButtons = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"quadratisch", checkedState:rb03, minWidth:labelWidth3});
								radiobuttonControls.add({staticLabel:"kreisfrmig", checkedState:rb04});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Variationen: ", minWidth:labelWidth2});
							with (varButtons = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"keine", checkedState:rb05, minWidth:labelWidth3});
								radiobuttonControls.add({staticLabel:"wie der Ochse pflgt", checkedState:rb06});
								radiobuttonControls.add({staticLabel:"spiralfrmig", checkedState:rb07});
								radiobuttonControls.add({staticLabel:"zufllige Reihenfolge", checkedState:rb08});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Zufllige Drehwinkel der Rahmen:"});
							staticTexts.add({staticLabel:" ", minWidth:48});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"plus/minus:", minWidth:labelWidth1});
							var rotaField = realEditboxes.add({editValue:nVal, minimumValue:0, maximumValue:10, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"   "});
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		if (noDoc) {
			var wdthVal = widthField.editValue;
			var hghtVal = heightField.editValue;
		}
		else {
			var wdthVal = wVal;
			var hghtVal = hVal;
		}
		var sizeVal = sizeField.editValue;
		var guttVal = guttField.editValue;
		var distVal = distField.editValue;
		var rowsVal = rowsField.editContents;
		var colsVal = colsField.editContents;
		var refDec  = refButtons.selectedButton;
		var shpDec  = shpButtons.selectedButton;
		var varDec  = varButtons.selectedButton;
		var rotVal  = rotaField.editValue;
		// den Dialog entfernen
		aDialog.destroy();
		// die Liste der Einstellungen ...
		var prefsList = new Array (wdthVal, hghtVal, sizeVal, guttVal, distVal, colsVal, rowsVal, refDec, shpDec, varDec, rotVal);
		// ... in eine Textkette verwandeln ...
		var prefString = prefsList.join("\n");
		// ... und zur Funktion schicken, welche sie in eine Datei schreibt
		writeResult(prefString);
		// den Variablen die Wahl des Anwenders zuweisen
		if (noDoc) {
			wVal = wdthVal;
			hVal = hghtVal;
		}
		// die Werte fr Spalten und Reihen prfen
		if (colsVal != "") {
			testCols = parseInt(colsVal);
			if (isNaN(testCols)) {
				alert (colsVal + " ist keine Zahl.", "Stop");
				exit();
			}
			else if (testCols < 1) {
				testCols = "";
			}
		}
		else {
			testCols = "";
		}
		if (rowsVal != "") {
			testRows = parseInt(rowsVal);
			if (isNaN(testRows)) {
				alert (rowsVal + " ist keine Zahl.", "Stop");
				exit();
			}
			else if (testRows < 1) {
				testRows = "";
			}
		}
		else {
			testRows = "";
		}
		return [wdthVal, hghtVal, sizeVal, guttVal, distVal, testCols, testRows, refDec, shpDec, varDec, rotVal];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// die Einstellungen zurcksetzen /////////////////////////////////////////////////////////////////
function resetAsBefore() {
	if (noDoc == false) {
		// den Nullpunkt zurcksetzen (falls notwendig) 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = zP; 
		}
		// Masseinheiten zurcksetzen (falls notwendig)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
		// die Ebene sperren (falls notwendig)
		if (isLocked) {
			curLayer.locked = true;
		}
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/farbenmuster207.txt");
	}
	else {
		var f = File("~/Library/Preferences/farbenmuster207.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die CMYK-Werte testen
function testCMYKvalues(c,m,y,k) {
	if (c>100) {
		alert ("C: " + c + " ?!?\nKeine Spassvogelwerte, bitte.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (m>100) {
		alert ("M: " + m + " ?!?\nKeine Spassvogelwerte, bitte.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (y>100) {
		alert (yChar + ": " + y + " ?!?\nKeine Spassvogelwerte, bitte.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (k>100) {
		alert (kChar + ": " + k + " ?!?\nKeine Spassvogelwerte, bitte.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (isNaN(k)) {
		return "no good";
	}
	return "okay";
}

// die RGB-Werte testen
function testRGBvalues(r,g,b) {
	if (r>255) {
		alert ("R: " + r + " ?!?\nKeine Spassvogelwerte, bitte.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (g>255) {
		alert (gChar + ": " + g + " ?!?\nKeine Spassvogelwerte, bitte.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (b>255) {
		alert ("B: " + b + " ?!?\nKeine Spassvogelwerte, bitte.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (isNaN(b)) {
		return "no good";
	}
	return "okay";
}